# Models

## The APILog object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"APILog":{"type":"object","required":["request","response"],"properties":{"request":{"allOf":[{"$ref":"#/components/schemas/APIRequest"}],"description":"HTTP request object","readOnly":true},"response":{"allOf":[{"$ref":"#/components/schemas/APIResponse"}],"description":"HTTP response object","readOnly":true}},"additionalProperties":false},"APIRequest":{"type":"object","required":["url","method","header","queryParameter","ipAddress","requestTimestamp","body"],"properties":{"url":{"type":"string","format":"","description":"Url of the request","readOnly":true},"method":{"type":"string","format":"","description":"The Http method that was used in the request. Possible values are:\n* GET\n* POST\n* PUT\n* DELETE","readOnly":true},"header":{"type":"object","additionalProperties":false,"description":"Any headers that were sent in the request","readOnly":true},"queryParameter":{"type":"string","format":"","description":"Any query parameters that were passed in the request","readOnly":true},"ipAddress":{"type":"string","format":"","description":"IP address of the client that performed the request","readOnly":true},"requestTimestamp":{"type":"integer","format":"integer","description":"The unix timestamp at which the API received the request","readOnly":true},"body":{"type":"object","additionalProperties":false,"anyOf":[{"type":"object"},{"type":"array"}],"description":"The (optional) body of the request","nullable":true,"readOnly":true}},"additionalProperties":false},"APIResponse":{"type":"object","required":["responseTime","code","body"],"properties":{"responseTime":{"type":"number","format":"float","description":"The time it took from the moment we receive the request from the webserver till the moment we send it back to the client, measured in seconds","readOnly":true},"code":{"type":"integer","format":"integer","description":"HTTP response status code","readOnly":true},"body":{"type":"object","additionalProperties":false,"anyOf":[{"type":"object"},{"type":"array"}],"description":"The body of the response, in case of GET method body will be null","nullable":true,"readOnly":true}},"additionalProperties":false}}}}
```

## The APIRequest object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"APIRequest":{"type":"object","required":["url","method","header","queryParameter","ipAddress","requestTimestamp","body"],"properties":{"url":{"type":"string","format":"","description":"Url of the request","readOnly":true},"method":{"type":"string","format":"","description":"The Http method that was used in the request. Possible values are:\n* GET\n* POST\n* PUT\n* DELETE","readOnly":true},"header":{"type":"object","additionalProperties":false,"description":"Any headers that were sent in the request","readOnly":true},"queryParameter":{"type":"string","format":"","description":"Any query parameters that were passed in the request","readOnly":true},"ipAddress":{"type":"string","format":"","description":"IP address of the client that performed the request","readOnly":true},"requestTimestamp":{"type":"integer","format":"integer","description":"The unix timestamp at which the API received the request","readOnly":true},"body":{"type":"object","additionalProperties":false,"anyOf":[{"type":"object"},{"type":"array"}],"description":"The (optional) body of the request","nullable":true,"readOnly":true}},"additionalProperties":false}}}}
```

## The APIResponse object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"APIResponse":{"type":"object","required":["responseTime","code","body"],"properties":{"responseTime":{"type":"number","format":"float","description":"The time it took from the moment we receive the request from the webserver till the moment we send it back to the client, measured in seconds","readOnly":true},"code":{"type":"integer","format":"integer","description":"HTTP response status code","readOnly":true},"body":{"type":"object","additionalProperties":false,"anyOf":[{"type":"object"},{"type":"array"}],"description":"The body of the response, in case of GET method body will be null","nullable":true,"readOnly":true}},"additionalProperties":false}}}}
```

## The AccessDocument object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccessDocument":{"type":"object","required":["id","documentType","documentNumber","documentExpiration"],"properties":{"id":{"type":"integer","format":"integer","description":"ID of the document","readOnly":true},"documentType":{"type":"integer","format":"integer","description":"Type of the document"},"documentNumber":{"type":"string","format":"","description":"Number of document"},"documentExpiration":{"type":"string","format":"","description":"Expiration date of document"}},"additionalProperties":false}}}}
```

## The AccountAPIKeyIPWhitelist object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountAPIKeyIPWhitelist":{"type":"object","required":["id","active","updatedAt"],"properties":{"id":{"type":"integer","format":"integer","description":"Whitelist ID","readOnly":true},"ipStart":{"type":"string","format":"","description":"Start IP of API key IP whitelist range","nullable":true},"ipEnd":{"type":"string","format":"","description":"End IP of API key IP whitelist range","nullable":true},"ipRange":{"type":"string","format":"","description":"CIDR IP range of API key whitelist","nullable":true},"comments":{"type":"string","format":"","description":"IP whitelist range comments","nullable":true},"active":{"type":"integer","format":"integer","description":"Whether or not this IP whitelist range is active"},"updatedAt":{"type":"integer","format":"integer","description":"Last time this IP whitelist range was updated","readOnly":true}},"additionalProperties":false}}}}
```

## The AccountActionLog object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountActionLog":{"type":"object","required":["remoteIP","title","description","date","time","timestamp"],"properties":{"remoteIP":{"type":"string","format":"","description":"Remote ip address","readOnly":true},"title":{"type":"string","format":"","description":"Title Of The action","readOnly":true},"description":{"type":"string","format":"","description":"A description about the action","readOnly":true},"date":{"type":"string","format":"","description":"Log creation date","readOnly":true,"deprecated":true},"time":{"type":"string","format":"","description":"Log creation time","readOnly":true,"deprecated":true},"timestamp":{"type":"integer","format":"integer","description":"The unix time at which the log was created","readOnly":true}},"additionalProperties":false}}}}
```

## The AccountApiKey object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountApiKey":{"type":"object","required":["id","category","key","assignOdpServerIps","used"],"properties":{"id":{"type":"integer","format":"integer","description":"API key ID","readOnly":true},"category":{"type":"integer","format":"integer","description":"API key access category"},"key":{"type":"string","format":"","description":"API key","readOnly":true},"note":{"type":"string","format":"","description":"API key note","nullable":true},"assignOdpServerIps":{"type":"integer","format":"integer","description":"Whether or not to assign ODP server IPs"},"used":{"type":"integer","format":"integer","description":"Number of times that the API key was used","readOnly":true},"expiresAt":{"type":"integer","format":"integer","description":"API key expiration time as UNIX timestamp","nullable":true}},"additionalProperties":false}}}}
```

## The AccountBillingDetails object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountBillingDetails":{"type":"object","required":["firstName","lastName","address","streetNumber","zipCode","city","countryCode","bundleInvoicesOfSameCategory","receivePaymentConfirmationsViaEmail","preferredPaymentMethod"],"properties":{"firstName":{"type":"string","format":"","description":"Billing first name."},"lastName":{"type":"string","format":"","description":"Billing last name."},"address":{"type":"string","format":"","description":"Billing address."},"streetNumber":{"type":"string","format":"","description":"Billing street number."},"zipCode":{"type":"string","format":"","description":"Billing ZIP code."},"city":{"type":"string","format":"","description":"Billing city."},"countryCode":{"type":"string","format":"","description":"Country code in ISO 3166-1 alpha-2 format."},"phoneNumber":{"type":"string","format":"","description":"Billing phone number. Either this or phoneNumberMobile is required.","nullable":true},"phoneNumberMobile":{"type":"string","format":"","description":"Billing mobile phone number. Either this or phoneNumber is required.","nullable":true},"emailAddressBilling":{"type":"string","format":"","description":"Email address for billing emails","nullable":true},"bundleInvoicesOfSameCategory":{"type":"integer","format":"integer","description":"Whether or not to bundle invoices of the same category"},"receivePaymentConfirmationsViaEmail":{"type":"integer","format":"integer","description":"Whether or not to send email confirmations via email"},"preferredPaymentMethod":{"type":"integer","format":"integer","description":"Preferred payment method"}},"additionalProperties":false}}}}
```

## The AccountDetails object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountDetails":{"type":"object","required":["accountType","firstName","lastName","address","streetNumber","zipCode","city","countryCode","emailAddress","unconfirmedEmail","emailAddressValidated","language","agreeDpa","isAllowedFlexMetal"],"properties":{"accountType":{"type":"integer","format":"integer","description":"Account type: 1 - consumer, 2 - business. Can only be updated by submitting a support ticket."},"companyName":{"type":"string","format":"","description":"Company name (for business accounts). Can only be updated by submitting a support ticket.","nullable":true},"vatNumber":{"type":"string","format":"","description":"VAT number (for business accounts). Can only be updated by submitting a support ticket.","nullable":true},"cocNumber":{"type":"string","format":"","description":"CoC number (only for Netherlands accounts). Can only be updated by submitting a support ticket.","nullable":true},"firstName":{"type":"string","format":"","description":"First name."},"lastName":{"type":"string","format":"","description":"Last name."},"address":{"type":"string","format":"","description":"Address - street name."},"streetNumber":{"type":"string","format":"","description":"House number"},"zipCode":{"type":"string","format":"","description":"ZIP / Post code."},"city":{"type":"string","format":"","description":"City."},"countryCode":{"type":"string","format":"","description":"Country code in ISO 3166-1 alpha-2 format."},"emailAddress":{"type":"string","format":"","description":"Email address","readOnly":true},"unconfirmedEmail":{"allOf":[{"$ref":"#/components/schemas/UnconfirmedEmail"}],"description":"Email address which is not confirmed yet","nullable":true,"readOnly":true},"emailAddressValidated":{"type":"integer","format":"integer","description":"Whether or not email address has been confirmed","nullable":true,"readOnly":true},"phoneNumber":{"type":"string","format":"","description":"Phone number. Either this or phoneNumberMobile is required","nullable":true},"phoneNumberMobile":{"type":"string","format":"","description":"Mobile phone number. Either this or phoneNumber is required","nullable":true},"language":{"type":"integer","format":"integer","description":"Preferred language: 0 - english, 1 - dutch"},"emailAddressAbuse":{"type":"string","format":"","description":"Email address for abuse emails","nullable":true},"newsletter":{"type":"integer","format":"integer","description":"Whether or not newsletter is subscribed to","nullable":true},"agreeToc":{"type":"integer","format":"integer","description":"Whether or not Terms and Conditions are agreed to. Cannot be changed after agreeing.","nullable":true},"agreeAup":{"type":"integer","format":"integer","description":"Whether or not Acceptable Use Policy is agreed to. Cannot be changed after agreeing.","nullable":true},"agreeDpa":{"type":"integer","format":"integer","description":"Whether or not Data Processing Agreement is agreed to. Cannot be changed after agreeing.","nullable":true},"isAllowedFlexMetal":{"type":"integer","format":"integer","description":"Whether or not the user is allowed to order flexmetal servers."}},"additionalProperties":false},"UnconfirmedEmail":{"type":"object","required":["email","expiresAt"],"properties":{"email":{"type":"string","format":"","description":"Email address which is not confirmed yet"},"expiresAt":{"type":"integer","format":"integer","description":"Expiry time of confirmation link","readOnly":true}},"additionalProperties":false,"nullable":true}}}}
```

## The AccountDocument object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountDocument":{"type":"object","required":["id","documentType","documentNumber","documentExpiration"],"properties":{"id":{"type":"integer","format":"integer","description":"ID of the document","readOnly":true},"documentType":{"type":"integer","format":"integer","description":"Type of the document"},"documentNumber":{"type":"string","format":"","description":"Number of document"},"documentExpiration":{"type":"string","format":"","description":"Expiration date of document"}},"additionalProperties":false}}}}
```

## The AccountFile object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountFile":{"type":"object","required":["id","category","name","filename","type","size","uploadedAt"],"properties":{"id":{"type":"integer","format":"integer","description":"File ID","readOnly":true},"category":{"type":"integer","format":"integer","description":"ID of the category of the file"},"name":{"type":"string","format":"","description":"File display name"},"filename":{"type":"string","format":"","description":"Name of the file"},"type":{"type":"string","format":"","description":"File MIME type","readOnly":true},"size":{"type":"integer","format":"integer","description":"File size in bytes","readOnly":true},"uploadedAt":{"type":"integer","format":"integer","description":"UNIX timestamp of when the file was uploaded","readOnly":true}},"additionalProperties":false}}}}
```

## The AccountIPWhitelist object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountIPWhitelist":{"type":"object","required":["id","active","createdAt"],"properties":{"id":{"type":"integer","format":"integer","description":"IP whitelist ID","readOnly":true},"ipStart":{"type":"string","format":"","description":"First IP in range","nullable":true},"ipEnd":{"type":"string","format":"","description":"Last IP in range","nullable":true},"ipRange":{"type":"string","format":"","description":"IP range with network suffix such as /24, /32, etc.","nullable":true},"description":{"type":"string","format":"","description":"Description of whitelisted IP or range"},"active":{"type":"integer","format":"integer","description":"Whether or not this whitelist entry is active"},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of when the IP whitelisting was created","readOnly":true}},"additionalProperties":false}}}}
```

## The AccountSignUp object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"AccountSignUp":{"type":"object","required":["emailAddress","password","firstName","lastName","newsletter","agreeToc","agreeAup","agreeDpa"],"properties":{"emailAddress":{"type":"string","format":"","description":"New Account Email Address"},"password":{"type":"string","format":"","description":"New Account Password"},"firstName":{"type":"string","format":"","description":"First name."},"lastName":{"type":"string","format":"","description":"Last name."},"newsletter":{"type":"integer","format":"integer","description":"Whether or not newsletter is subscribed to"},"agreeToc":{"type":"integer","format":"integer","description":"Whether or not Terms and Conditions are agreed to. Cannot be changed after agreeing."},"agreeAup":{"type":"integer","format":"integer","description":"Whether or not Acceptable Use Policy is agreed to. Cannot be changed after agreeing."},"agreeDpa":{"type":"integer","format":"integer","description":"Whether or not Data Processing Agreement is agreed to. Cannot be changed after agreeing."}},"additionalProperties":false}}}}
```

## The ApplicationInstanceStopMethod object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ApplicationInstanceStopMethod":{"type":"object","properties":{"methodId":{"type":"integer","format":"integer","description":"Stop method type, list of types can be found in: [GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods)"},"timeout":{"type":"integer","format":"integer","description":"Stop method timeout in seconds, default value is 1800 seconds."}},"additionalProperties":false}}}}
```

## The CDNUserFeaturesModel object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CDNUserFeaturesModel":{"type":"object","required":["type","features"],"properties":{"type":{"type":"string","format":""},"features":{"type":"array","items":{"$ref":"#/components/schemas/FeatureModel"}}},"additionalProperties":false},"FeatureModel":{"type":"object","required":["geometry","properties"],"properties":{"geometry":{"$ref":"#/components/schemas/GeometryModel"},"properties":{"$ref":"#/components/schemas/PropertiesModel"}},"additionalProperties":false},"GeometryModel":{"type":"object","required":["type","coordinates"],"properties":{"type":{"type":"string","format":"","description":"The type of the geometry"},"coordinates":{"type":"array","items":{"type":"number","format":"float"},"description":"The geographic coordinates"}},"additionalProperties":false},"PropertiesModel":{"type":"object","required":["value"],"properties":{"value":{"type":"integer","format":"integer","description":"The heat value for the coordinate"}},"additionalProperties":false}}}}
```

## The CPUTriggerRule object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CPUTriggerRule":{"type":"object","required":["operator","triggerWindow","threshold"],"properties":{"operator":{"type":"integer","format":"integer","description":"The operator used for this rule, you can find the list on this endpoint [GET /v3/trigger/type/operators](all#/Trigger/getTriggerTypeOperators)"},"triggerWindow":{"type":"integer","format":"integer","description":"The time window for a rule, time will be in seconds"},"threshold":{"type":"integer","format":"integer","description":"The percentage of cpu (between 0 and 100%) usage were the event should be triggered on"}},"additionalProperties":false}}}}
```

## The CalcCategory object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcCategory":{"type":"object","required":["id","name"],"properties":{"id":{"type":"integer","format":"integer","description":"ID of a category"},"name":{"type":"string","format":"","description":"Name of a category"}},"additionalProperties":false}}}}
```

## The CalcCategoryLocation object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcCategoryLocation":{"type":"object","required":["categoryIds","locationId","countryName","countryNameShort","regionId","regionName","continent","city","locationBwPriceDedi","locationBwOverusePriceDedi","locationBwPriceColo","locationBwOverusePriceColo"],"properties":{"categoryIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"Category IDs"},"locationId":{"type":"integer","format":"integer","description":"Location ID"},"countryName":{"type":"string","format":"","description":"Name of the country of this location"},"countryNameShort":{"type":"string","format":"","description":"Name of the country of this location"},"regionId":{"type":"integer","format":"integer","description":"Region ID"},"regionName":{"type":"string","format":"","description":"Name of the region this location is situated in (regions are smaller than continents, but may be a whole continent)."},"continent":{"type":"string","format":"","description":"Name of the continent of this location"},"city":{"type":"string","format":"","description":"Name of the city of this location"},"locationBwPriceDedi":{"type":"integer","format":"integer","description":"Dedicated server bandwidth price per TB for this location, in cents"},"locationBwOverusePriceDedi":{"type":"integer","format":"integer","description":"Dedicated server bandwidth overuse price per TB for this location, in cents"},"locationBwPriceColo":{"type":"integer","format":"integer","description":"Colocation bandwidth price per TB for this location, in cents"},"locationBwOverusePriceColo":{"type":"integer","format":"integer","description":"Colocation bandwidth overuse price per TB for this location, in cents"}},"additionalProperties":false}}}}
```

## The CalcCategoryMargins object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcCategoryMargins":{"type":"object","required":["resellerTypeId","resellerTypeName","categoryId","marginFactor"],"properties":{"resellerTypeId":{"type":"integer","format":"integer","description":"ID of a reseller type"},"resellerTypeName":{"type":"string","format":"","description":"Name of a reseller type"},"categoryId":{"type":"integer","format":"integer","description":"ID of the category"},"marginFactor":{"type":"number","format":"float","description":"ID of a category"}},"additionalProperties":false}}}}
```

## The CalcConfig object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcConfig":{"type":"object","required":["id","tag","locationId","price","setup","flags","bwPriceDedi","bwPriceColo","fixed","noDowngrade","instantDeliverable","groups"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration ID"},"tag":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration tag"},"locationId":{"type":"integer","format":"integer","description":"Location ID, as provided by /locations"},"price":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration price in cents"},"setup":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration setup price in cents"},"flags":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration flags\nIMMUTABLE         1;\nINSTANT_CONFIG    2;\nALLOW_DOWNGRADE   4;\nIS_DEAL           8;\nON_DEAL_PAGE      16;\nCOLO_NO_CONN      32;\nPRIVATE_CONFIG    64;"},"bwPriceDedi":{"type":"integer","format":"integer","description":"TB price for dedicated servers, in cents"},"bwPriceColo":{"type":"integer","format":"integer","description":"TB price for colocation, in cents"},"fixed":{"type":"boolean","description":"Whether this configuration is adjustable"},"noDowngrade":{"type":"boolean","description":"Whether items in this configuration can be downgraded"},"instantDeliverable":{"type":"boolean","description":"Whether this configuration can be setup instantly and automatically (low wait time)"},"groups":{"type":"array","items":{"$ref":"#/components/schemas/CalcGroup"},"description":"All item groups for this configuration"}},"additionalProperties":false},"CalcGroup":{"type":"object","required":["id","name","code","type","fixed","step","flags","noDowngrade","displayOrder","dependencyGroupId","dependencyItemIds","notes","items","defaultItemId"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group ID"},"name":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group name"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group code"},"type":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group type (a human readable unique identifier)"},"fixed":{"type":"boolean","description":"Whether items in this configuration group are adjustable"},"step":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group divider (for visual differentiation between related groups)"},"flags":{"type":"integer","format":"integer","description":"FLAG_HASQUANTITY                  1\nFLAG_HASPRICE                     2\nFLAG_ALLOW_EMPTY_SELECTION        4\nFLAG_INCLUDE_ON_INVOICE_IF_EMPTY  8\nFLAG_NOTE_ACTIVE                  16\nFLAG_APPLY_PERIOD_DISCOUNT        32\nFLAG_EXCLUDE_FROM_UPGRADES        64"},"noDowngrade":{"type":"boolean","description":"Whether items in this configuration group can be downgraded"},"displayOrder":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group display order"},"dependencyGroupId":{"type":"integer","format":"integer","description":"If > 0, this group will only relevant / shown if the dependency group and/or item is selected."},"dependencyItemIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"If dependencyGroupId > 0, this group will only relevant / shown if (one of) these dependencyItemIds are selected."},"notes":{"type":"string","format":"","description":"Optional notes for a group, for displaying purposes."},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcItem"},"description":"All items for this configuration group"},"defaultItemId":{"type":"integer","format":"integer","description":"Default item in a group"}},"additionalProperties":false},"CalcItem":{"type":"object","required":["id","code","name","shortName","ident","quantity","specifications","flags","price","setupPrice","priceLinkGroupId","priceLinkPercentage","displayOrder","excludeConfigs","excludeLocationIds"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration item ID"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration item code"},"name":{"type":"string","format":"","description":"Item name"},"shortName":{"type":"string","format":"","description":"Item name short"},"ident":{"type":"string","format":"","description":"Item human readable unique identifier"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"},"specifications":{"type":"array","items":{"$ref":"#/components/schemas/CalcItemSpecification"},"description":"Item specifications"},"flags":{"type":"integer","format":"integer","description":"FLAG_NOTE_ACTIVE 1"},"price":{"type":"integer","format":"integer","description":"Item price in cents"},"setupPrice":{"type":"integer","format":"integer","description":"Item setup price in cents"},"priceLinkGroupId":{"type":"integer","format":"integer","description":"Item price is dependent on the price of this group or the entire order.\nIf -1, the price is a percentage (priceLinkPercentage) of the order.\nIf > 0, the price is a percentage (priceLinkPercentage) of the indicated group."},"priceLinkPercentage":{"type":"number","format":"float","description":"The percentage as refered to by priceLinkGroupId description."},"displayOrder":{"type":"integer","format":"integer","description":"Item display order"},"excludeConfigs":{"type":"array","items":{"type":"integer","format":"integer"},"description":"ApplicationInstanceConfiguration IDs from which this item must be excluded."},"excludeLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"Location IDs from which this item must be excluded."}},"additionalProperties":false},"CalcItemSpecification":{"type":"object","required":["id","name","value","dataType","mandatory"],"properties":{"id":{"type":"integer","format":"integer","description":"Item specification ID"},"name":{"type":"string","format":"","description":"Item specification name"},"value":{"type":"string","format":"","description":"Item specification value"},"dataType":{"type":"string","format":"","description":"Item specification data type (int, float, string)"},"mandatory":{"type":"integer","format":"integer","description":"Whether this item specification is mandatory"}},"additionalProperties":false}}}}
```

## The CalcGroup object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcGroup":{"type":"object","required":["id","name","code","type","fixed","step","flags","noDowngrade","displayOrder","dependencyGroupId","dependencyItemIds","notes","items","defaultItemId"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group ID"},"name":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group name"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group code"},"type":{"type":"string","format":"","description":"ApplicationInstanceConfiguration group type (a human readable unique identifier)"},"fixed":{"type":"boolean","description":"Whether items in this configuration group are adjustable"},"step":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group divider (for visual differentiation between related groups)"},"flags":{"type":"integer","format":"integer","description":"FLAG_HASQUANTITY                  1\nFLAG_HASPRICE                     2\nFLAG_ALLOW_EMPTY_SELECTION        4\nFLAG_INCLUDE_ON_INVOICE_IF_EMPTY  8\nFLAG_NOTE_ACTIVE                  16\nFLAG_APPLY_PERIOD_DISCOUNT        32\nFLAG_EXCLUDE_FROM_UPGRADES        64"},"noDowngrade":{"type":"boolean","description":"Whether items in this configuration group can be downgraded"},"displayOrder":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration group display order"},"dependencyGroupId":{"type":"integer","format":"integer","description":"If > 0, this group will only relevant / shown if the dependency group and/or item is selected."},"dependencyItemIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"If dependencyGroupId > 0, this group will only relevant / shown if (one of) these dependencyItemIds are selected."},"notes":{"type":"string","format":"","description":"Optional notes for a group, for displaying purposes."},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcItem"},"description":"All items for this configuration group"},"defaultItemId":{"type":"integer","format":"integer","description":"Default item in a group"}},"additionalProperties":false},"CalcItem":{"type":"object","required":["id","code","name","shortName","ident","quantity","specifications","flags","price","setupPrice","priceLinkGroupId","priceLinkPercentage","displayOrder","excludeConfigs","excludeLocationIds"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration item ID"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration item code"},"name":{"type":"string","format":"","description":"Item name"},"shortName":{"type":"string","format":"","description":"Item name short"},"ident":{"type":"string","format":"","description":"Item human readable unique identifier"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"},"specifications":{"type":"array","items":{"$ref":"#/components/schemas/CalcItemSpecification"},"description":"Item specifications"},"flags":{"type":"integer","format":"integer","description":"FLAG_NOTE_ACTIVE 1"},"price":{"type":"integer","format":"integer","description":"Item price in cents"},"setupPrice":{"type":"integer","format":"integer","description":"Item setup price in cents"},"priceLinkGroupId":{"type":"integer","format":"integer","description":"Item price is dependent on the price of this group or the entire order.\nIf -1, the price is a percentage (priceLinkPercentage) of the order.\nIf > 0, the price is a percentage (priceLinkPercentage) of the indicated group."},"priceLinkPercentage":{"type":"number","format":"float","description":"The percentage as refered to by priceLinkGroupId description."},"displayOrder":{"type":"integer","format":"integer","description":"Item display order"},"excludeConfigs":{"type":"array","items":{"type":"integer","format":"integer"},"description":"ApplicationInstanceConfiguration IDs from which this item must be excluded."},"excludeLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"Location IDs from which this item must be excluded."}},"additionalProperties":false},"CalcItemSpecification":{"type":"object","required":["id","name","value","dataType","mandatory"],"properties":{"id":{"type":"integer","format":"integer","description":"Item specification ID"},"name":{"type":"string","format":"","description":"Item specification name"},"value":{"type":"string","format":"","description":"Item specification value"},"dataType":{"type":"string","format":"","description":"Item specification data type (int, float, string)"},"mandatory":{"type":"integer","format":"integer","description":"Whether this item specification is mandatory"}},"additionalProperties":false}}}}
```

## The CalcItem object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcItem":{"type":"object","required":["id","code","name","shortName","ident","quantity","specifications","flags","price","setupPrice","priceLinkGroupId","priceLinkPercentage","displayOrder","excludeConfigs","excludeLocationIds"],"properties":{"id":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration item ID"},"code":{"type":"string","format":"","description":"ApplicationInstanceConfiguration item code"},"name":{"type":"string","format":"","description":"Item name"},"shortName":{"type":"string","format":"","description":"Item name short"},"ident":{"type":"string","format":"","description":"Item human readable unique identifier"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"},"specifications":{"type":"array","items":{"$ref":"#/components/schemas/CalcItemSpecification"},"description":"Item specifications"},"flags":{"type":"integer","format":"integer","description":"FLAG_NOTE_ACTIVE 1"},"price":{"type":"integer","format":"integer","description":"Item price in cents"},"setupPrice":{"type":"integer","format":"integer","description":"Item setup price in cents"},"priceLinkGroupId":{"type":"integer","format":"integer","description":"Item price is dependent on the price of this group or the entire order.\nIf -1, the price is a percentage (priceLinkPercentage) of the order.\nIf > 0, the price is a percentage (priceLinkPercentage) of the indicated group."},"priceLinkPercentage":{"type":"number","format":"float","description":"The percentage as refered to by priceLinkGroupId description."},"displayOrder":{"type":"integer","format":"integer","description":"Item display order"},"excludeConfigs":{"type":"array","items":{"type":"integer","format":"integer"},"description":"ApplicationInstanceConfiguration IDs from which this item must be excluded."},"excludeLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"Location IDs from which this item must be excluded."}},"additionalProperties":false},"CalcItemSpecification":{"type":"object","required":["id","name","value","dataType","mandatory"],"properties":{"id":{"type":"integer","format":"integer","description":"Item specification ID"},"name":{"type":"string","format":"","description":"Item specification name"},"value":{"type":"string","format":"","description":"Item specification value"},"dataType":{"type":"string","format":"","description":"Item specification data type (int, float, string)"},"mandatory":{"type":"integer","format":"integer","description":"Whether this item specification is mandatory"}},"additionalProperties":false}}}}
```

## The CalcItemSpecification object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcItemSpecification":{"type":"object","required":["id","name","value","dataType","mandatory"],"properties":{"id":{"type":"integer","format":"integer","description":"Item specification ID"},"name":{"type":"string","format":"","description":"Item specification name"},"value":{"type":"string","format":"","description":"Item specification value"},"dataType":{"type":"string","format":"","description":"Item specification data type (int, float, string)"},"mandatory":{"type":"integer","format":"integer","description":"Whether this item specification is mandatory"}},"additionalProperties":false}}}}
```

## The CalcOrder object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcOrder":{"type":"object","required":["id","finalized","createdAt","modifiedAt","quantity","title","categoryId","categoryName","configTag","configName","configFlags","instantDeliverable","price","setup","vat","vatPercentage","items"],"properties":{"id":{"type":"integer","format":"integer","description":"Order ID"},"finalized":{"type":"boolean","description":"Whether the order has been added to your cart."},"createdAt":{"type":"integer","format":"integer","description":"Order creation unix timestamp"},"modifiedAt":{"type":"integer","format":"integer","description":"Order last modification unix timestamp"},"quantity":{"type":"integer","format":"integer","description":"Order quantity multiplier"},"title":{"type":"string","format":"","description":"Order title"},"categoryId":{"type":"integer","format":"integer","description":"Order shop category ID"},"categoryName":{"type":"string","format":"","description":"Order shop category name"},"configTag":{"type":"string","format":"","description":"The tag of the configuration this order is based upon."},"configName":{"type":"string","format":"","description":"The name of the configuration this order is based upon."},"configFlags":{"type":"integer","format":"integer","description":"ApplicationInstanceConfiguration flags\nIMMUTABLE         1;\nINSTANT_CONFIG    2;\nALLOW_DOWNGRADE   4;\nIS_DEAL           8;\nON_DEAL_PAGE      16;\nCOLO_NO_CONN      32;\nPRIVATE_CONFIG    64;"},"instantDeliverable":{"type":"boolean","description":"Whether this configuration can be setup instantly and automatically (low wait time)"},"price":{"type":"integer","format":"integer","description":"Order price in cents"},"setup":{"type":"integer","format":"integer","description":"Order setup price in cents"},"vat":{"type":"integer","format":"integer","description":"Order VAT in cents"},"vatPercentage":{"type":"number","format":"float","description":"Order VAT percentage"},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcOrderItem"},"description":"All items and quantities in the order"}},"additionalProperties":false},"CalcOrderItem":{"type":"object","required":["itemId","groupId","quantity"],"properties":{"itemId":{"type":"integer","format":"integer","description":"Item ID"},"groupId":{"type":"integer","format":"integer","description":"Item group ID"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"}},"additionalProperties":false}}}}
```

## The CalcOrderCreate object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcOrderCreate":{"type":"object","required":["configTag","couponTag","instantFinalize"],"properties":{"configTag":{"type":"string","format":"","description":"Configuration tag to create an order from."},"couponTag":{"type":"string","format":"","description":"Coupon tag to apply to the order."},"instantFinalize":{"type":"boolean","description":"Whether you want to immediately make the order available for checkout."}},"additionalProperties":false}}}}
```

## The CalcOrderItem object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcOrderItem":{"type":"object","required":["itemId","groupId","quantity"],"properties":{"itemId":{"type":"integer","format":"integer","description":"Item ID"},"groupId":{"type":"integer","format":"integer","description":"Item group ID"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"}},"additionalProperties":false}}}}
```

## The CalcOrderMeta object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcOrderMeta":{"type":"object","required":["id","finalized","instantDeliverable"],"properties":{"id":{"type":"integer","format":"integer","description":"Order ID"},"finalized":{"type":"boolean","description":"True if an order has been added to the cart."},"instantDeliverable":{"type":"boolean","description":"Whether this order is instantly deliverable (normally speaking)"}},"additionalProperties":false}}}}
```

## The CalcOrderQuote object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcOrderQuote":{"type":"object","required":["firstName","lastName","email","phone"],"properties":{"userId":{"type":"integer","format":"integer","description":"Customer's user ID"},"firstName":{"type":"string","minLength":2,"maxLength":64,"format":"","description":"Customer's first name"},"lastName":{"type":"string","minLength":2,"maxLength":128,"format":"","description":"Customer's last name"},"companyName":{"type":"string","maxLength":120,"format":"","description":"Customer's company name (optional)"},"email":{"type":"string","maxLength":128,"format":"","description":"Customer's email address"},"phone":{"type":"string","minLength":5,"maxLength":15,"format":"","description":"Customer's phone number"},"remarks":{"type":"string","maxLength":4000,"format":"","description":"Remarks contain specific question(s) regarding the quote"}},"additionalProperties":false}}}}
```

## The CalcOrderUpdate object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcOrderUpdate":{"type":"object","required":["quantity","items"],"properties":{"quantity":{"type":"integer","format":"integer","description":"Order quantity"},"items":{"type":"array","items":{"$ref":"#/components/schemas/CalcOrderItem"},"description":"Order items"}},"additionalProperties":false},"CalcOrderItem":{"type":"object","required":["itemId","groupId","quantity"],"properties":{"itemId":{"type":"integer","format":"integer","description":"Item ID"},"groupId":{"type":"integer","format":"integer","description":"Item group ID"},"quantity":{"type":"integer","format":"integer","description":"Item quantity"}},"additionalProperties":false}}}}
```

## The CalcServiceVatPercentage object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CalcServiceVatPercentage":{"type":"object","required":["taxPercent"],"properties":{"taxPercent":{"type":"number","format":"float","description":"VAT percentage"}},"additionalProperties":false}}}}
```

## The CallbackSetting object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CallbackSetting":{"type":"object","required":["id","url"],"properties":{"id":{"type":"integer","format":"integer","description":"Callback setting ID, can be used as callbackSettingId in other endpoints.","readOnly":true},"url":{"type":"string","format":"","description":"This is the url that the system will use when the callback is executed."},"urlDescription":{"type":"string","format":"","description":"Description of the callback setting."},"headers":{"type":"string","format":"","description":"For sending additional meta information about the callback request."}},"additionalProperties":false}}}}
```

## The ColocatedAccess object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocatedAccess":{"type":"object","required":["id","email","mobile","firstName","lastName","birthDate","companyName"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of colocation access request","readOnly":true},"visitorId":{"type":"integer","format":"integer","description":"The ID of the visitor"},"email":{"type":"string","format":"","description":"The e-mail address of the visitor"},"mobile":{"type":"string","format":"","description":"The mobile phone number of the visitor"},"firstName":{"type":"string","format":"","description":"The first name of the visitor"},"lastName":{"type":"string","format":"","description":"The last name of the visitor"},"birthDate":{"type":"string","format":"","description":"The birth date of the visitor"},"companyName":{"type":"string","format":"","description":"The company name of visitor"},"colocatedAccessServer":{"type":"array","items":{"$ref":"#/components/schemas/ColocatedAccessServer"},"description":"The colocated servers to which access is requested. if this is empty then the visitor get access to all colocated servers of the requester","nullable":true},"temporaryAccess":{"type":"integer","format":"integer","description":"If this field is set to 1, then the visitor has a temporary access","nullable":true},"visitRequester":{"type":"integer","format":"integer","description":"If this field is set to 1, then this visitor can add a temporary access for other visitor","nullable":true},"permanentRequester":{"type":"integer","format":"integer","description":"If this field is set to 1, then this visitor can request a permanent access for other visitor","nullable":true}},"additionalProperties":false},"ColocatedAccessServer":{"type":"object","required":["coloserverId","rackname"],"properties":{"coloserverId":{"type":"integer","format":"integer","description":"The ID of the colocated server where the visitor has access to"},"rackname":{"type":"string","format":"","description":"The name of the rack where the visitor has access to"}},"additionalProperties":false}}}}
```

## The ColocatedAccessDetails object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocatedAccessDetails":{"type":"object","required":["id","visitorId","email","mobile","firstName","lastName","birthDate","countryEn","accountDocument","createdBy","newEntry","status"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of colocation access request","readOnly":true},"visitorId":{"type":"integer","format":"integer","description":"The ID of the user"},"datacenterId":{"type":"integer","format":"integer","description":"The ID of data center","nullable":true},"dateverified":{"type":"string","format":"","description":"The date when the user was verified","nullable":true},"dateonlist":{"type":"string","format":"","description":"The date when the user was added to the access list","nullable":true},"dateofflist":{"type":"string","format":"","description":"The date when the user was removed from the access list","nullable":true},"email":{"type":"string","format":"","description":"The e-mail address of the visitor"},"mobile":{"type":"string","format":"","description":"The mobile phone number of the visitor"},"firstName":{"type":"string","format":"","description":"The first name of the visitor"},"lastName":{"type":"string","format":"","description":"The last name of the visitor"},"birthDate":{"type":"string","format":"","description":"The birth date of the user. The format is YYYY-MM-DD"},"companyName":{"type":"string","format":"","description":"The company name of the visitor","nullable":true},"city":{"type":"string","format":"","description":"The city of the visitor","nullable":true},"countryEn":{"type":"string","format":"","description":"The country name of the visitor","readOnly":true},"colocatedAccessServers":{"type":"array","items":{"$ref":"#/components/schemas/ColocatedAccessServer"},"description":"The colocated server to which access is requested","nullable":true},"adminNotesReadOnly":{"type":"string","format":"","description":"Notes for admins","nullable":true},"accountDocument":{"type":"array","items":{"$ref":"#/components/schemas/AccountDocument"},"description":"The account document of the user","readOnly":true},"checked":{"type":"string","format":"","description":"Was the user checked?","nullable":true},"createdBy":{"type":"integer","format":"integer","description":"ID of user creator","readOnly":true},"newEntry":{"type":"integer","format":"integer","description":"Is this a new entry","readOnly":true},"temporaryAccess":{"type":"integer","format":"integer","description":"temporaryAccess If this field is set to 1, then has the visitor a temporary access","nullable":true},"fingerPrintId":{"type":"integer","format":"integer","description":"The print ID from Syntegro system","nullable":true},"printMade":{"type":"string","format":"","description":"Was the print made","nullable":true},"visitRequester":{"type":"integer","format":"integer","description":"If this field is set to 1, then this visitor can add a temporary access for other visitor","nullable":true},"permanentRequester":{"type":"integer","format":"integer","description":"If this field is set to 1, then this visitor can request a permanent access for other visitor","nullable":true},"syntegroEmployeeCode":{"type":"string","format":"","description":"The Syntegro employee code of visitor","nullable":true},"status":{"type":"string","format":"","description":"The status of the visitor (granted, pending, denied, revoked, suspended)","readOnly":true}},"additionalProperties":false},"ColocatedAccessServer":{"type":"object","required":["coloserverId","rackname"],"properties":{"coloserverId":{"type":"integer","format":"integer","description":"The ID of the colocated server where the visitor has access to"},"rackname":{"type":"string","format":"","description":"The name of the rack where the visitor has access to"}},"additionalProperties":false},"AccountDocument":{"type":"object","required":["id","documentType","documentNumber","documentExpiration"],"properties":{"id":{"type":"integer","format":"integer","description":"ID of the document","readOnly":true},"documentType":{"type":"integer","format":"integer","description":"Type of the document"},"documentNumber":{"type":"string","format":"","description":"Number of document"},"documentExpiration":{"type":"string","format":"","description":"Expiration date of document"}},"additionalProperties":false}}}}
```

## The ColocatedAccessServer object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocatedAccessServer":{"type":"object","required":["coloserverId","rackname"],"properties":{"coloserverId":{"type":"integer","format":"integer","description":"The ID of the colocated server where the visitor has access to"},"rackname":{"type":"string","format":"","description":"The name of the rack where the visitor has access to"}},"additionalProperties":false}}}}
```

## The ColocatedAlert object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocatedAlert":{"type":"object","required":["id","percentage","sendMail","sendTicket","triggered","createdAt"],"properties":{"id":{"type":"integer","format":"integer","description":"Colocation alert ID","readOnly":true},"percentage":{"type":"integer","format":"integer","description":"At what percentage of bandwidth usage to trigger the alert"},"sendMail":{"type":"integer","format":"integer","description":"Will send an email notification when alert is triggered"},"sendTicket":{"type":"integer","format":"integer","description":"WIll create a ticket notification when alert is triggered"},"triggered":{"type":"integer","format":"integer","description":"UNIX timestamp of the last time the alert was triggered","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"UNIX timestamp of the time the alert was created","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocatedRack object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocatedRack":{"type":"object","required":["rack","rentedUnits"],"properties":{"rack":{"type":"string","format":"","description":"Suit number and rack number","readOnly":true},"rentedUnits":{"type":"integer","format":"integer","description":"Number of units in colocation service","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocatedServer object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocatedServer":{"type":"object","required":["id","datacenter","rack","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","paymentTerm","pricePerMonth","pricePerTbOveruse","currencyId","bandwidthBillingType","bandwidthContractual","trafficSum","trafficSumMonthMbit","outgoingTrafficSum","incomingTrafficSum","powerMaxAmpere","powerKwhPrice","powerMeter","powerSumHistory","network","uplinks","unlimitedIngress"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of the colocation service","readOnly":true},"name":{"type":"string","format":"","description":"The name of the colocation service"},"datacenter":{"allOf":[{"$ref":"#/components/schemas/DataCenter"}],"description":"The data center details","readOnly":true},"rack":{"allOf":[{"$ref":"#/components/schemas/ColocatedRack"}],"description":"The rack details in which the server is installed","readOnly":true},"dateStart":{"type":"string","format":"","description":"Contract start date","readOnly":true},"dateEnd":{"type":"string","format":"","description":"The date until which the service is paid","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"Contract cancel date if contract is cancelled","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"Contract end date","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"The duration of the contract in months","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"The extended period of the contract in months","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"The order-name to which the server belongs"},"paymentTerm":{"type":"integer","format":"integer","description":"The duration in which the invoice has to be paid after receiving.","readOnly":true},"pricePerMonth":{"type":"string","format":"","description":"The price of this colocated server per month in cents","readOnly":true},"pricePerTbOveruse":{"type":"string","format":"","description":"The price of traffic overuse in cents (per TB) (see `currencyId` for currency)","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency in which the various 'price' fields are:\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true},"bandwidthContractual":{"type":"integer","format":"integer","description":"The contractual maximum bandwidth usage value. In GB if bandwidthBillingType equals `2`, in mbit otherwise","readOnly":true},"trafficSum":{"type":"integer","format":"integer","description":"The total used traffic (Mbit or GB, incoming + outgoing)","readOnly":true},"trafficSumMonthMbit":{"type":"integer","format":"integer","description":"The total used traffic (Mbit) for 95th percentile","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB)","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB)","readOnly":true},"powerMaxAmpere":{"type":"string","format":"","description":"Contractual maximum usable amperage","readOnly":true},"powerKwhPrice":{"type":"string","format":"","description":"The power price per kWh in cents","readOnly":true},"powerMeter":{"type":"integer","format":"integer","description":"The current power meter(kWh)","readOnly":true},"powerSumHistory":{"type":"array","items":{"$ref":"#/components/schemas/PowerConsumptionPerDay"},"description":"The history of the power usage and the power meter","readOnly":true},"network":{"type":"array","items":{"$ref":"#/components/schemas/Network"},"description":"The network connection specifications","readOnly":true},"uplinks":{"type":"array","items":{"$ref":"#/components/schemas/ColocatedServerUplink"},"description":"The available uplinks for this colocated server","readOnly":true},"unlimitedIngress":{"type":"integer","format":"integer","description":"Does the service have free incoming traffic?","readOnly":true}},"additionalProperties":false},"DataCenter":{"type":"object","required":["address","contact","wifi"],"properties":{"address":{"allOf":[{"$ref":"#/components/schemas/DatacenterAddress"}],"description":"The address of the data center","readOnly":true},"contact":{"allOf":[{"$ref":"#/components/schemas/DatacenterContact"}],"description":"The contact information","readOnly":true},"wifi":{"allOf":[{"$ref":"#/components/schemas/WifiCredential"}],"description":"The wifi credentials","readOnly":true}},"additionalProperties":false},"DatacenterAddress":{"type":"object","required":["name","address","zipCode","city","country"],"properties":{"name":{"type":"string","format":"","description":"The name of the Location","readOnly":true},"address":{"type":"string","format":"","description":"The address of the location","readOnly":true},"zipCode":{"type":"string","format":"","description":"The zip-code of the location","readOnly":true},"city":{"type":"string","format":"","description":"The city name","readOnly":true},"country":{"type":"string","format":"","description":"The country name","readOnly":true}},"additionalProperties":false},"DatacenterContact":{"type":"object","required":["phoneNumber","emergencyPhoneNumber","faxNumber","emailAddress"],"properties":{"phoneNumber":{"type":"string","format":"","description":"The phone-number","readOnly":true},"emergencyPhoneNumber":{"type":"string","format":"","description":"The emergency phone-number","readOnly":true},"faxNumber":{"type":"string","format":"","description":"The fax-number","readOnly":true},"emailAddress":{"type":"string","format":"","description":"The email-address","readOnly":true}},"additionalProperties":false},"WifiCredential":{"type":"object","required":["networkName","userName","password"],"properties":{"networkName":{"type":"string","format":"","description":"Wifi SSID","readOnly":true},"userName":{"type":"string","format":"","description":"Wifi user-name","readOnly":true},"password":{"type":"string","format":"","description":"Wifi Password","readOnly":true}},"additionalProperties":false},"ColocatedRack":{"type":"object","required":["rack","rentedUnits"],"properties":{"rack":{"type":"string","format":"","description":"Suit number and rack number","readOnly":true},"rentedUnits":{"type":"integer","format":"integer","description":"Number of units in colocation service","readOnly":true}},"additionalProperties":false},"PowerConsumptionPerDay":{"type":"object","required":["date","powerMeter","powerUsed"],"properties":{"date":{"type":"string","format":"","description":"The corresponding date","readOnly":true},"powerMeter":{"type":"string","format":"","description":"The power meter(kWh)","readOnly":true},"powerUsed":{"type":"string","format":"","description":"The used power(kWh)","readOnly":true}},"additionalProperties":false},"Network":{"type":"object","required":["vlanId","ipRange","ipRangeCustom"],"properties":{"vlanId":{"type":"integer","format":"integer","description":"The vlan ID","readOnly":true},"ipRange":{"type":"array","items":{"$ref":"#/components/schemas/IpRangeCidr"},"description":"Defines a list of IP ranges with a prefix in CIDR format (such as 123.123.123.64/26)","readOnly":true},"ipRangeCustom":{"type":"array","items":{"$ref":"#/components/schemas/IpRangeCustom"},"description":"Defines a list of custom IP ranges that do not use prefixes but have an arbitrary start and end ip range (such as 123.123.123.100 - 123.123.123.200)","readOnly":true}},"additionalProperties":false},"IpRangeCidr":{"type":"object","required":["network","netmask","prefix","gateway","rDns"],"properties":{"network":{"type":"string","format":"","description":"The ip of the network","readOnly":true},"netmask":{"type":"string","format":"","description":"The range netmask","readOnly":true},"prefix":{"type":"string","format":"","description":"CIDR prefix, including leading slash","readOnly":true},"gateway":{"type":"string","format":"","description":"The gateway IP","readOnly":true},"vrrp1":{"type":"string","format":"","description":"The virtual router redundancy protocol 1","nullable":true},"vrrp2":{"type":"string","format":"","description":"The virtual router redundancy protocol 1","nullable":true},"rDns":{"type":"array","items":{"$ref":"#/components/schemas/RDns"},"description":"RDNS records","readOnly":true}},"additionalProperties":false},"RDns":{"type":"object","required":["hostname","ip"],"properties":{"hostname":{"type":"string","format":"","description":"The hostname"},"ip":{"type":"string","format":"","description":"The corresponding ip for the host","readOnly":true}},"additionalProperties":false},"IpRangeCustom":{"type":"object","required":["networkStart","networkEnd","gateway","rDns"],"properties":{"networkStart":{"type":"string","format":"","description":"The start ip of the network","readOnly":true},"networkEnd":{"type":"string","format":"","description":"The end ip of the network","readOnly":true},"gateway":{"type":"string","format":"","description":"The gateway IP","readOnly":true},"vrrp1":{"type":"string","format":"","description":"The virtual router redundancy protocol 1","nullable":true},"vrrp2":{"type":"string","format":"","description":"The virtual router redundancy protocol 1","nullable":true},"rDns":{"type":"array","items":{"$ref":"#/components/schemas/RDns"},"description":"RDNS records","readOnly":true}},"additionalProperties":false},"ColocatedServerUplink":{"type":"object","required":["uplinkId","aggregate"],"properties":{"uplinkId":{"type":"integer","format":"integer","description":"The cacti ID of the uplink","readOnly":true},"aggregate":{"type":"boolean","description":"True if the uplink is an aggregated uplink, false if it is not aggregated","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocatedServerUplink object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocatedServerUplink":{"type":"object","required":["uplinkId","aggregate"],"properties":{"uplinkId":{"type":"integer","format":"integer","description":"The cacti ID of the uplink","readOnly":true},"aggregate":{"type":"boolean","description":"True if the uplink is an aggregated uplink, false if it is not aggregated","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocationNetworkDataTelemetry object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocationNetworkDataTelemetry":{"type":"object","required":["timestamp","networkIngress","networkEgress"],"properties":{"timestamp":{"type":"integer","format":"integer","description":"The time at which the last update occurred","readOnly":true},"networkIngress":{"type":"integer","format":"integer","description":"The network's ingress in bytes","readOnly":true},"networkEgress":{"type":"integer","format":"integer","description":"The network's egress in bytes","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocationNetworkTelemetry object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocationNetworkTelemetry":{"type":"object","required":["unit","data"],"properties":{"unit":{"type":"string","format":"","description":"Unit of data frequency (hour by default)","readOnly":true},"data":{"type":"array","items":{"$ref":"#/components/schemas/ColocationNetworkDataTelemetry"},"description":"Contains the data object","readOnly":true}},"additionalProperties":false},"ColocationNetworkDataTelemetry":{"type":"object","required":["timestamp","networkIngress","networkEgress"],"properties":{"timestamp":{"type":"integer","format":"integer","description":"The time at which the last update occurred","readOnly":true},"networkIngress":{"type":"integer","format":"integer","description":"The network's ingress in bytes","readOnly":true},"networkEgress":{"type":"integer","format":"integer","description":"The network's egress in bytes","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocationOveruseTelemetry object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocationOveruseTelemetry":{"type":"object","required":["coloId","coloName","orderedBandwidth","usedBandwidth"],"properties":{"coloId":{"type":"integer","format":"integer","description":"The ID of the colocation","readOnly":true},"coloName":{"type":"string","format":"","description":"The name of the colocation","readOnly":true},"orderedBandwidth":{"type":"number","format":"float","description":"Allowed bandwidth of the host","readOnly":true},"usedBandwidth":{"type":"number","format":"float","description":"Used bandwidth of the host","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocationPDUHistoryDataTelemetry object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocationPDUHistoryDataTelemetry":{"type":"object","required":["timestamp","amps","volts","kwh","powerMeter"],"properties":{"timestamp":{"type":"integer","format":"integer","description":"The time at which the last update occurred","readOnly":true},"amps":{"type":"number","format":"float","description":"The value of amps at that time","readOnly":true},"volts":{"type":"number","format":"float","description":"The value of volts at that time","readOnly":true},"kwh":{"type":"number","format":"float","description":"The value of kwh at that time","readOnly":true},"powerMeter":{"type":"integer","format":"integer","description":"The value of power meter at that time","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocationPDUHistoryTelemetry object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocationPDUHistoryTelemetry":{"type":"object","required":["unit","data"],"properties":{"unit":{"type":"string","format":"","description":"Unit of data frequency, which is always `null` in this endpoint. This property is there\nfor consistency across all telemetry endpoints. It's `null` because the data is not aggregated","readOnly":true},"data":{"type":"array","items":{"$ref":"#/components/schemas/ColocationPDUHistoryDataTelemetry"},"description":"Contains the data object","readOnly":true}},"additionalProperties":false},"ColocationPDUHistoryDataTelemetry":{"type":"object","required":["timestamp","amps","volts","kwh","powerMeter"],"properties":{"timestamp":{"type":"integer","format":"integer","description":"The time at which the last update occurred","readOnly":true},"amps":{"type":"number","format":"float","description":"The value of amps at that time","readOnly":true},"volts":{"type":"number","format":"float","description":"The value of volts at that time","readOnly":true},"kwh":{"type":"number","format":"float","description":"The value of kwh at that time","readOnly":true},"powerMeter":{"type":"integer","format":"integer","description":"The value of power meter at that time","readOnly":true}},"additionalProperties":false}}}}
```

## The ColocationPDUTelemetry object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ColocationPDUTelemetry":{"type":"object","required":["id","name","kwh"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of the colocation service","readOnly":true},"name":{"type":"string","format":"","description":"The name of the colocation service","readOnly":true},"kwh":{"type":"integer","format":"integer","description":"Current month kilo watts per hour","readOnly":true}},"additionalProperties":false}}}}
```

## The Conduit object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"Conduit":{"type":"object","required":["conduitName","powerMeter","amperage","peakAmperage"],"properties":{"conduitName":{"type":"string","format":"","description":"The feed name"},"powerMeter":{"type":"integer","format":"integer","description":"The last registered counter value for this outlet"},"amperage":{"type":"number","format":"float","description":"The total amperage supported by the outlet"},"peakAmperage":{"type":"number","format":"float","description":"The peak amperage"}},"additionalProperties":false}}}}
```

## The Country object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"Country":{"type":"object","required":["id","code","name","continent"],"properties":{"id":{"type":"integer","format":"integer","description":"The country ID","readOnly":true},"code":{"type":"string","format":"","description":"The country code","readOnly":true},"name":{"type":"string","format":"","description":"The country name","readOnly":true},"continent":{"type":"string","format":"","description":"The continent name","readOnly":true}},"additionalProperties":false}}}}
```

## The CrossConnect object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"CrossConnect":{"type":"object","required":["id","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","paymentTerm","monthlyFee","setupFee","currencyId","colocatedServerId","hostId","locationIdSideA","locationIdSideAName","locationIdSideZ","locationIdSideZName","locationDetails","rackIdSideA","rackIdSideAName","rackIdSideZ","rackIdSideZName","goLiveDate","internalId","patchInternalName","thirdPartyId","vendorId","cableType","cableSpeed","connectorSideAType","connectorSideZType","diverseFromPatchId","customerNotes","uplinks","connectivityType","outgoingTrafficSum","incomingTrafficSum","bandwidthBillingType"],"properties":{"id":{"type":"integer","format":"integer","description":"Cross connect ID","readOnly":true},"dateStart":{"type":"string","format":"","description":"Start date of the cross connect","readOnly":true},"dateEnd":{"type":"string","format":"","description":"End date of the cross connect","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"Cancelled date of the cross connect","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"End contract date of the cross connect","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"Contract period of the cross connect","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"Extend period of the cross connect","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"paymentTerm":{"type":"integer","format":"integer","description":"Payment term of the cross connect","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"Purchase order of the cross connect"},"monthlyFee":{"type":"string","format":"","description":"Monthly fee of the cross connect in cents","readOnly":true},"setupFee":{"type":"string","format":"","description":"Setup fee of the cross connect in cents","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency ID\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"colocatedServerId":{"type":"integer","format":"integer","description":"Colocated server ID","readOnly":true},"hostId":{"type":"integer","format":"integer","description":"Host ID","readOnly":true},"locationIdSideA":{"type":"integer","format":"integer","description":"Location ID of the Side A","readOnly":true},"locationIdSideAName":{"type":"string","format":"","description":"Location name of the Side A","readOnly":true},"locationIdSideZ":{"type":"integer","format":"integer","description":"Location ID of the Side B","readOnly":true},"locationIdSideZName":{"type":"string","format":"","description":"Location name of the Side B","readOnly":true},"locationDetails":{"type":"string","format":"","description":"Location details","readOnly":true},"rackIdSideA":{"type":"integer","format":"integer","description":"Rack ID of the Side A","readOnly":true},"rackIdSideAName":{"type":"string","format":"","description":"Rack Name of the Side A","readOnly":true},"rackIdSideZ":{"type":"integer","format":"integer","description":"Rack ID of the Side B","readOnly":true},"rackIdSideZName":{"type":"string","format":"","description":"Rack Name of the Side B","readOnly":true},"goLiveDate":{"type":"string","format":"","description":"Go live date","readOnly":true},"internalId":{"type":"string","format":"","description":"Internal ID of the service","readOnly":true},"patchInternalName":{"type":"string","format":"","description":"Internal name of the patch","readOnly":true},"patchCustomerName":{"type":"string","format":"","description":"Customer name of the patch"},"thirdPartyId":{"type":"string","format":"","description":"Third party ID of the service","readOnly":true},"vendorId":{"type":"integer","format":"integer","description":"Vendor ID of the service","readOnly":true},"cableType":{"type":"integer","format":"integer","description":"Type of cable","readOnly":true},"cableSpeed":{"type":"integer","format":"integer","description":"Cable speed","readOnly":true},"connectorSideAType":{"type":"integer","format":"integer","description":"Connector of Side A","readOnly":true},"connectorSideZType":{"type":"integer","format":"integer","description":"Connector of Side Z","readOnly":true},"diverseFromPatchId":{"type":"integer","format":"integer","description":"Diverse from patch id","readOnly":true},"customerNotes":{"type":"string","format":"","description":"Notes of the customer","readOnly":true},"uplinks":{"type":"array","items":{"$ref":"#/components/schemas/UpLink"},"description":"The available uplinks for this cross connect","readOnly":true},"connectivityType":{"type":"string","format":"","description":"The type of connectivity service\nFollowing will be possible values:\n* Connectivity: Transport\n* Connectivity: IP connectivity\n* Connectivity: Crossconnect","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB - defined by \"bandwidthBillingType\")","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB - defined by \"bandwidthBillingType\")","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true}},"additionalProperties":false},"UpLink":{"type":"object","required":["side","uplinkId"],"properties":{"side":{"type":"string","format":"","description":"Side of the uplink\nFollowing will be possible values for sides uplink:\n* A\n* Z","readOnly":true},"uplinkId":{"type":"integer","format":"integer","description":"Up Link ID","readOnly":true}},"additionalProperties":false}}}}
```

## The Currency object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"Currency":{"type":"object","required":["id","name","conversionRateToEuro","decimals"],"properties":{"id":{"type":"integer","format":"integer","description":"Currency ID","readOnly":true},"name":{"type":"string","format":"","description":"Currency Name","readOnly":true},"sign":{"type":"string","format":"","description":"Currency Sign"},"conversionRateToEuro":{"type":"number","format":"float","description":"Exchange rate to Euro","readOnly":true},"decimals":{"type":"integer","format":"integer","description":"Number of decimals","readOnly":true}},"additionalProperties":false}}}}
```

## The DataCenter object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"DataCenter":{"type":"object","required":["address","contact","wifi"],"properties":{"address":{"allOf":[{"$ref":"#/components/schemas/DatacenterAddress"}],"description":"The address of the data center","readOnly":true},"contact":{"allOf":[{"$ref":"#/components/schemas/DatacenterContact"}],"description":"The contact information","readOnly":true},"wifi":{"allOf":[{"$ref":"#/components/schemas/WifiCredential"}],"description":"The wifi credentials","readOnly":true}},"additionalProperties":false},"DatacenterAddress":{"type":"object","required":["name","address","zipCode","city","country"],"properties":{"name":{"type":"string","format":"","description":"The name of the Location","readOnly":true},"address":{"type":"string","format":"","description":"The address of the location","readOnly":true},"zipCode":{"type":"string","format":"","description":"The zip-code of the location","readOnly":true},"city":{"type":"string","format":"","description":"The city name","readOnly":true},"country":{"type":"string","format":"","description":"The country name","readOnly":true}},"additionalProperties":false},"DatacenterContact":{"type":"object","required":["phoneNumber","emergencyPhoneNumber","faxNumber","emailAddress"],"properties":{"phoneNumber":{"type":"string","format":"","description":"The phone-number","readOnly":true},"emergencyPhoneNumber":{"type":"string","format":"","description":"The emergency phone-number","readOnly":true},"faxNumber":{"type":"string","format":"","description":"The fax-number","readOnly":true},"emailAddress":{"type":"string","format":"","description":"The email-address","readOnly":true}},"additionalProperties":false},"WifiCredential":{"type":"object","required":["networkName","userName","password"],"properties":{"networkName":{"type":"string","format":"","description":"Wifi SSID","readOnly":true},"userName":{"type":"string","format":"","description":"Wifi user-name","readOnly":true},"password":{"type":"string","format":"","description":"Wifi Password","readOnly":true}},"additionalProperties":false}}}}
```

## The DatacenterAddress object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"DatacenterAddress":{"type":"object","required":["name","address","zipCode","city","country"],"properties":{"name":{"type":"string","format":"","description":"The name of the Location","readOnly":true},"address":{"type":"string","format":"","description":"The address of the location","readOnly":true},"zipCode":{"type":"string","format":"","description":"The zip-code of the location","readOnly":true},"city":{"type":"string","format":"","description":"The city name","readOnly":true},"country":{"type":"string","format":"","description":"The country name","readOnly":true}},"additionalProperties":false}}}}
```

## The DatacenterContact object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"DatacenterContact":{"type":"object","required":["phoneNumber","emergencyPhoneNumber","faxNumber","emailAddress"],"properties":{"phoneNumber":{"type":"string","format":"","description":"The phone-number","readOnly":true},"emergencyPhoneNumber":{"type":"string","format":"","description":"The emergency phone-number","readOnly":true},"faxNumber":{"type":"string","format":"","description":"The fax-number","readOnly":true},"emailAddress":{"type":"string","format":"","description":"The email-address","readOnly":true}},"additionalProperties":false}}}}
```

## The EmailChange object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"EmailChange":{"type":"object","required":["emailAddress","password"],"properties":{"emailAddress":{"type":"string","format":"","description":"New email address"},"password":{"type":"string","format":"","description":"Password of the user account"}},"additionalProperties":false}}}}
```

## The EmailConfirmation object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"EmailConfirmation":{"type":"object","required":["userId","hash"],"properties":{"userId":{"type":"integer","format":"integer","description":"UserId"},"hash":{"type":"string","format":"","description":"Hash"}},"additionalProperties":false}}}}
```

## The EmailConfirmationResend object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"EmailConfirmationResend":{"type":"object","required":["email"],"properties":{"email":{"type":"string","format":"","description":"Email to resend the confirmation for"}},"additionalProperties":false}}}}
```

## The EmailConfirmationResult object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"EmailConfirmationResult":{"type":"object","required":["emailAddress","emailType"],"properties":{"emailAddress":{"type":"string","format":"","description":"The e-mail address that was validated"},"emailType":{"type":"string","format":"","description":"Type of e-mail that was validated, possible types can be main, billing or abuse"}},"additionalProperties":false}}}}
```

## The Error object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}}}
```

## The ErrorDetails object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}}}
```

## The FeatureModel object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FeatureModel":{"type":"object","required":["geometry","properties"],"properties":{"geometry":{"$ref":"#/components/schemas/GeometryModel"},"properties":{"$ref":"#/components/schemas/PropertiesModel"}},"additionalProperties":false},"GeometryModel":{"type":"object","required":["type","coordinates"],"properties":{"type":{"type":"string","format":"","description":"The type of the geometry"},"coordinates":{"type":"array","items":{"type":"number","format":"float"},"description":"The geographic coordinates"}},"additionalProperties":false},"PropertiesModel":{"type":"object","required":["value"],"properties":{"value":{"type":"integer","format":"integer","description":"The heat value for the coordinate"}},"additionalProperties":false}}}}
```

## The FlexMetalCapacityCommit object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalCapacityCommit":{"type":"object","required":["location","commits"],"properties":{"location":{"allOf":[{"$ref":"#/components/schemas/FlexMetalLocation"}],"description":"Data center location","readOnly":true},"commits":{"type":"array","items":{"$ref":"#/components/schemas/FlexMetalInstanceTypeCommit"},"description":"Committed capacity per instance type","readOnly":true}},"additionalProperties":false},"FlexMetalLocation":{"type":"object","required":["id","name","shortName","displayName","countryId","countryName","countryShortName"],"properties":{"id":{"type":"integer","format":"integer","description":"ID of the location","readOnly":true},"name":{"type":"string","format":"","description":"Name of the location","readOnly":true},"shortName":{"type":"string","format":"","description":"Short name of the location","readOnly":true},"displayName":{"type":"string","format":"","description":"Display name of the location","readOnly":true},"countryId":{"type":"integer","format":"integer","description":"Country ID of the location","readOnly":true},"countryName":{"type":"string","format":"","description":"Country name of the Location","readOnly":true},"countryShortName":{"type":"string","format":"","description":"Country short name of the Location","readOnly":true}},"additionalProperties":false},"FlexMetalInstanceTypeCommit":{"type":"object","required":["instanceType","capacity","inUse"],"properties":{"instanceType":{"allOf":[{"$ref":"#/components/schemas/FlexMetalInstanceType"}],"description":"Instance type","readOnly":true},"capacity":{"type":"integer","format":"integer","description":"Total commit of this instance type","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Instances in use","readOnly":true}},"additionalProperties":false},"FlexMetalInstanceType":{"type":"object","required":["id","locationId","name","sockets","cores","memory","memoryType","storage","storageType","generationName"],"properties":{"id":{"type":"integer","format":"integer","description":"Id of instance type","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"LocationId of instance type","readOnly":true},"name":{"type":"string","format":"","description":"Name of instance type","readOnly":true},"sockets":{"type":"integer","format":"integer","description":"Sockets of instance type","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Cores of instance type","readOnly":true},"memory":{"type":"integer","format":"integer","description":"Memory of instance type","readOnly":true},"memoryType":{"type":"string","format":"","description":"Memory type of instance type","readOnly":true},"storage":{"type":"integer","format":"integer","description":"Storage of instance type","readOnly":true},"storageType":{"type":"string","format":"","description":"Storage type of instance type","readOnly":true},"generationName":{"type":"string","format":"","description":"Generation name of instance type","readOnly":true}},"additionalProperties":false}}}}
```

## The FlexMetalInstanceType object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalInstanceType":{"type":"object","required":["id","locationId","name","sockets","cores","memory","memoryType","storage","storageType","generationName"],"properties":{"id":{"type":"integer","format":"integer","description":"Id of instance type","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"LocationId of instance type","readOnly":true},"name":{"type":"string","format":"","description":"Name of instance type","readOnly":true},"sockets":{"type":"integer","format":"integer","description":"Sockets of instance type","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Cores of instance type","readOnly":true},"memory":{"type":"integer","format":"integer","description":"Memory of instance type","readOnly":true},"memoryType":{"type":"string","format":"","description":"Memory type of instance type","readOnly":true},"storage":{"type":"integer","format":"integer","description":"Storage of instance type","readOnly":true},"storageType":{"type":"string","format":"","description":"Storage type of instance type","readOnly":true},"generationName":{"type":"string","format":"","description":"Generation name of instance type","readOnly":true}},"additionalProperties":false}}}}
```

## The FlexMetalInstanceTypeCommit object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalInstanceTypeCommit":{"type":"object","required":["instanceType","capacity","inUse"],"properties":{"instanceType":{"allOf":[{"$ref":"#/components/schemas/FlexMetalInstanceType"}],"description":"Instance type","readOnly":true},"capacity":{"type":"integer","format":"integer","description":"Total commit of this instance type","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Instances in use","readOnly":true}},"additionalProperties":false},"FlexMetalInstanceType":{"type":"object","required":["id","locationId","name","sockets","cores","memory","memoryType","storage","storageType","generationName"],"properties":{"id":{"type":"integer","format":"integer","description":"Id of instance type","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"LocationId of instance type","readOnly":true},"name":{"type":"string","format":"","description":"Name of instance type","readOnly":true},"sockets":{"type":"integer","format":"integer","description":"Sockets of instance type","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Cores of instance type","readOnly":true},"memory":{"type":"integer","format":"integer","description":"Memory of instance type","readOnly":true},"memoryType":{"type":"string","format":"","description":"Memory type of instance type","readOnly":true},"storage":{"type":"integer","format":"integer","description":"Storage of instance type","readOnly":true},"storageType":{"type":"string","format":"","description":"Storage type of instance type","readOnly":true},"generationName":{"type":"string","format":"","description":"Generation name of instance type","readOnly":true}},"additionalProperties":false}}}}
```

## The FlexMetalInstanceTypePartial object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalInstanceTypePartial":{"type":"object","required":["id","name"],"properties":{"id":{"type":"integer","format":"integer","description":"Instance type ID","readOnly":true},"name":{"type":"string","format":"","description":"Instance type name","readOnly":true}},"additionalProperties":false}}}}
```

## The FlexMetalKernelParam object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalKernelParam":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Key of the kernel param"},"value":{"type":"string","format":"","description":"Value of the kernel param"}},"additionalProperties":false}}}}
```

## The FlexMetalLocation object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalLocation":{"type":"object","required":["id","name","shortName","displayName","countryId","countryName","countryShortName"],"properties":{"id":{"type":"integer","format":"integer","description":"ID of the location","readOnly":true},"name":{"type":"string","format":"","description":"Name of the location","readOnly":true},"shortName":{"type":"string","format":"","description":"Short name of the location","readOnly":true},"displayName":{"type":"string","format":"","description":"Display name of the location","readOnly":true},"countryId":{"type":"integer","format":"integer","description":"Country ID of the location","readOnly":true},"countryName":{"type":"string","format":"","description":"Country name of the Location","readOnly":true},"countryShortName":{"type":"string","format":"","description":"Country short name of the Location","readOnly":true}},"additionalProperties":false}}}}
```

## The FlexMetalLocationPartial object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalLocationPartial":{"type":"object","required":["id","name"],"properties":{"id":{"type":"integer","format":"integer","description":"ID of the location","readOnly":true},"name":{"type":"string","format":"","description":"Name of the location","readOnly":true}},"additionalProperties":false}}}}
```

## The FlexMetalOperatingSystemRequest object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalOperatingSystemRequest":{"type":"object","required":["slug"],"properties":{"slug":{"type":"string","format":"","description":"Identifier of the OS. Available operating systems can be obtained from /v3/operatingsystem. Use the `slug` field from the response."},"kernelParams":{"type":"array","items":{"$ref":"#/components/schemas/FlexMetalKernelParam"},"description":"Kernel params for the PXE stage of the OS installation. Most operating systems do not require these, but e.g. Talos does."},"partitions":{"type":"array","items":{"$ref":"#/components/schemas/FlexMetalPartition"},"description":"Custom partitions for the OS installation. If not provided, the default partitioning scheme will be used."},"ipxeScriptUrl":{"type":"string","format":"","description":"The URL to your custom iPXE boot menu file. Can and must be used in combination with OS slug custom-ipxe."}},"additionalProperties":false},"FlexMetalKernelParam":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Key of the kernel param"},"value":{"type":"string","format":"","description":"Value of the kernel param"}},"additionalProperties":false},"FlexMetalPartition":{"type":"object","required":["target","filesystem","size"],"properties":{"target":{"type":"string","format":"","description":"Mount point for the partition"},"filesystem":{"type":"string","format":"","description":"Type of filesystem to use for the target. Allowed: ext2, ext3, ext4, xfs"},"size":{"type":"integer","format":"integer","description":"The size of the partition, in MB. Use -1 to indicate usage of the remaining space on the disk."}},"additionalProperties":false}}}}
```

## The FlexMetalOperatingSystemResponse object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalOperatingSystemResponse":{"type":"object","required":["slug"],"properties":{"slug":{"type":"string","format":"","description":"Identifier of the OS. Available operating systems can be obtained from /v3/operatingsystem. Use the `slug` field from the response."}},"additionalProperties":false}}}}
```

## The FlexMetalPartition object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalPartition":{"type":"object","required":["target","filesystem","size"],"properties":{"target":{"type":"string","format":"","description":"Mount point for the partition"},"filesystem":{"type":"string","format":"","description":"Type of filesystem to use for the target. Allowed: ext2, ext3, ext4, xfs"},"size":{"type":"integer","format":"integer","description":"The size of the partition, in MB. Use -1 to indicate usage of the remaining space on the disk."}},"additionalProperties":false}}}}
```

## The FlexMetalQuotaUsage object

```json
{"openapi":"3.0.1","info":{"title":"i3D.net Endpoints","version":"3.0.0"},"components":{"schemas":{"FlexMetalQuotaUsage":{"type":"object","required":["instanceType","quotaType","contractId","quota","usage"],"properties":{"instanceType":{"allOf":[{"$ref":"#/components/schemas/FlexMetalInstanceTypePartial"}],"description":"Instance type","readOnly":true},"quotaType":{"type":"string","format":"","description":"The type of quota. Can be \"onDemand\" or \"commit\".","readOnly":true},"contractId":{"type":"string","format":"","description":"The contract identifier of commited resources. Empty for generic quota."},"quota":{"type":"integer","format":"integer","description":"The assigned quota number of server resources, for this location and instance type.","readOnly":true},"usage":{"type":"integer","format":"integer","description":"The current usage of server resources, for this location and instance type.","readOnly":true}},"additionalProperties":false},"FlexMetalInstanceTypePartial":{"type":"object","required":["id","name"],"properties":{"id":{"type":"integer","format":"integer","description":"Instance type ID","readOnly":true},"name":{"type":"string","format":"","description":"Instance type name","readOnly":true}},"additionalProperties":false}}}}
```

## The FlexMetalServer object

```json
[...]
